//
//  ConversationsPresenter.swift
//  VKExt
//
//  Created programmist_NA on 20.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit

import UIKit
import SwiftyJSON
import RealmSwift
import SwiftyVK
import Reachability

class ConversationsPresenter: ConversationsPresenterProtocol {
    weak private var view: ConversationsViewProtocol?
    var interactor: ConversationsInteractorProtocol?
    private let router: ConversationsWireframeProtocol

    let realm = try! Realm()
    let reachability = Reachability()

    init(interface: ConversationsViewProtocol, interactor: ConversationsInteractorProtocol?, router: ConversationsWireframeProtocol) {
        self.view = interface
        self.interactor = interactor
        self.router = router
    }

    // Старт
    func start() {
        interactor?.start()
    }
    
    // Есть ли подключение к сети
    var isReachable: Bool {
        if reachability?.currentReachabilityStatus == .notReachable {
            return false
        } else {
            return true
        }
    }
    
    func presentData(response: Conversations.Model.Response.ResponseType) {
        switch response {
        case .presentConversation(conversation: let conversation):
            _ = ConversationViewModel.init(cells: [conversationCellViewModel(from: conversation)], footerTitle: "")
        case .presentConversations(conversations: let conversations):
            let cells = conversations.compactMap { (item) in
                conversationCellViewModel(from: item)
            }
            
            _ = ConversationViewModel.init(cells: cells, footerTitle: "")
        case .presentFooterLoader:
            break
        case .presentFooterError(message: _):
            break
        }
    }
    
    private func conversationCellViewModel(from conversation: Conversation) -> ConversationViewModel.Cell {
        let conversationCellViewModel = ConversationViewModel.Cell.init(isMuted: conversation.isMuted, unreadStatus: conversation.unreadStatus, isOutgoing: conversation.isOutgoing, senderId: conversation.senderId, displayName: conversation.displayName, peerId: conversation.peerId, type: conversation.type, localId: conversation.localId, lastMessageId: conversation.lastMessageId, inRead: conversation.inRead, outRead: conversation.outRead, canWriteAllowed: conversation.canWriteAllowed, canWriteReason: conversation.canWriteReason, isImportantDialog: conversation.isImportantDialog, isMarkedUnread: conversation.isMarkedUnread, membersCount: conversation.membersCount, title: conversation.title, state: conversation.state, activeIds: conversation.activeIds, isGroupChannel: conversation.isGroupChannel, disabledUntil: conversation.disabledUntil, disabledForever: conversation.disabledForever, noSound: conversation.noSound, unreadCount: conversation.unreadCount, date: conversation.date, dateInteger: conversation.dateInteger, fromId: conversation.fromId, messageId: conversation.messageId, out: conversation.out, text: conversation.text, conversationMessageId: conversation.conversationMessageId, isImportantMessage: conversation.isImportantMessage, randomId: conversation.randomId, isTyping: conversation.isTyping, attachmentType: conversation.secondType, forwardMessagesCount: conversation.forwardMessagesCount, hasReplyMessage: conversation.hasReplyMessage, hasAttachments: conversation.hasAttachments, hasForwardedMessages: conversation.hasForwardedMessages, interlocutorId: conversation.interlocutorId, interlocutorName: conversation.interlocutorName, interlocutorPhoto50: conversation.interlocutorPhoto50, interlocutorPhoto100: conversation.interlocutorPhoto100, interlocutorPhoto200: conversation.interlocutorPhoto200, isOnline: conversation.isOnline, isMobileOnline: conversation.isMobileOnline, sex: conversation.sex, lastSeen: conversation.lastSeen, verified: conversation.verified, isRemoved: conversation.isRemoved, removingFlag: conversation.removingFlag, isAggressiveTypingActive: conversation.isAggressiveTypingActive, aggressiveTypingType: conversation.aggressiveTypingType, isPrivateConversation: conversation.isPrivateConversation)
        return conversationCellViewModel
    }
    
    // Действие при ошибке
    @available(*, deprecated, message: "Используйте onEvent(message: _)")
    func onError(message: String, _ style: MessageViewState) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.2, execute: {
            self.onEvent(message: message, style)
        })
    }
    
    // Действие при событии
    func onEvent(message: String, _ style: MessageViewState) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.1, execute: {
            self.view?.showStatusError(message: message, error: nil, style, with: false)
            self.onLoaded()
        })
    }
    
    // При окончании загрузки
    func onLoaded() {
        DispatchQueue.main.async {
            self.view?.finishLoading()
            self.view?.availabilityLoader(hasNeed: false)
        }
    }
    
    func onSearched() {
        DispatchQueue.main.async {
            self.view?.finishSearch()
            self.view?.availabilityLoader(hasNeed: false)
        }
    }
    
    // Обработка нажатия на диалог
    func onTapConversation(at indexPath: IndexPath) {
        guard let conversation = self.getConversation(at: indexPath) else { return }
        router.openConversation(from: conversation)
    }
    
    func onTapPerformProfile(userId: Int) {
        router.openProfile(userId: userId)
    }
    
    // Обработка смены режима уведомлений
    func onChangeSilenceMode(peerId: Int, sound: Int) {
        guard let interactor = interactor else { return }
        interactor.setSilenceMode(peerId: peerId, sound: sound)
    }
    
    // Oбработка удаления диалога
    func onDeleteConversation(peerId: Int) {
        guard let interactor = interactor else { return }
        interactor.deleteConversation(peerId: peerId)
    }
    
    // Обработка действия "Прочитать сообщение"
    func onTapReadConversation(at indexPath: IndexPath) {
        guard let interactor = interactor else { return }
        let conversations = realm.objects(Conversation.self)
        guard conversations.count != 0 else { return }
        let conversation = conversations.sorted { $0.dateInteger > $1.dateInteger }.filter { !$0.isPrivateConversation }[indexPath.row]
        interactor.readMessage(peerId: conversation.peerId)
    }
    
    // Обработка действия "Отметить сообщение непрочитанным"
    func onTapUnreadConversation(at indexPath: IndexPath) {
        guard let interactor = interactor else { return }
        let conversations = realm.objects(Conversation.self)
        guard conversations.count != 0 else { return }
        let conversation = conversations.sorted { $0.dateInteger > $1.dateInteger }.filter { !$0.isPrivateConversation }[indexPath.row]
        interactor.markAsUnreadConversation(peerId: conversation.peerId)
    }
    
    // Получить диалог по индексу
    func getConversation(at indexPath: IndexPath) -> Conversation? {
        let conversations = realm.objects(Conversation.self)
        guard conversations.count != 0 else { return nil }
        let conversation = conversations.sorted { $0.dateInteger > $1.dateInteger }.filter { !$0.isPrivateConversation }[indexPath.row]
        return conversation
    }
    
    // Обработка ошибки
    func onHandleError(error: VKError) {
        switch error {
        case .unknown(let error):
            DispatchQueue.main.async {
                self.view?.showStatusError(message: error.localizedDescription, error: nil, .error, with: false)
                self.onLoaded()
            }
        case .api(let apiError):
            DispatchQueue.main.async {
                self.view?.showStatusError(message: apiError.message, error: nil, .error, with: false)
                self.onLoaded()
            }
        default:
            break
        }
    }
    
    // При поиске чатов
    func onSearch(q: String?) {
        guard let interactor = interactor else { return }
        interactor.searchConversation(q: q, count: 200)
    }
    
    // Искомые диалоги
    var searchConversations: [Conversation] {
        guard let interactor = interactor else { return [] }
        return interactor.searchConversations
    }
    
    // Количество сообщений в базе
    var messagesCount: Int? {
        let items = realm.objects(Conversation.self).filter { !$0.isPrivateConversation }
        return items.count
    }
    
    // Количество непрочитанных сообщений в базе
    var unreadMessagesCount: Int? {
        let items = realm.objects(Conversation.self).filter { !$0.isPrivateConversation }.filter { $0.unreadStatus == .unreadIn }
        return items.count
    }
    
    // Общее количество непрочитанных
    var unread: Int? {
        return interactor!.unread
    }
}
